#include <iostream>
#include <conio.h>
#include "agentspace.h"

class B {
	private: 
		int id;
	public:
		B(int id) : id(id) {};
		~B() {};
};

class A {
	private:
		static int id;
		int _id;
	public:
		B *b;
		A() {
			id++;
			_id = id;
			b = new B(_id);
			cout << _id << "created" << endl;
		};
		~A() {
			delete b;
			b = NULL;
			cout << _id << "destroyed" << endl;
		}
		inline A& clone() {
			return *(new A());
		}
};

int A::id = 0;

static Synchronize sync;

class MyAgent1 : public Agent {
	protected:
		void init (string args) {
			timer_attach(1000,1000);
    }
    void sense_select_act (int pid) {
			A a;
	    space_write("a",a.clone(),1500); 
		}
	public:
		MyAgent1 (string args) : Agent(args) {};
};

class MyAgent2 : public Agent {
	protected:
		void init (string args) {
			trigger_attach("*",TRIGGER_MATCHING);
    }
    void sense_select_act (int pid) {
			delay(500);
			SpaceIterator<A> it;
    	for (it=space_read_begin(pid); it!=space_read_end(pid); ++it) {
	    	sync.lock();
	    	if (it->value.b == NULL) cout << "JE ZLE" << endl;
	    	else cout << "JE DOBRE" << endl;
	    	sync.unlock();
			}
		}
	public:
		MyAgent2 (string args) : Agent(args) {};
};

int main () {
	MyAgent1 a1("");
	MyAgent2 a2("");
	getch();
	a1.kill();
	getch();
}
