#ifndef agentspace_timer_INCLUDED
#define agentspace_timer_INCLUDED

#include "thread.h"
#include <sys/time.h>

class Timer {
	private:
		static unsigned int nid;
		unsigned int _nid;
		Proxy *proxy;
        struct timespec tim;
        int period;
        bool active;
	public:
		Timer(Proxy& proxy);
		bool operator<(const Timer& rhs) const;
		bool operator==(const Timer& rhs) const;
		unsigned int tid();
		struct timespec *getTiming();
		bool isActive();
		bool isCyclic();
		int getPeriod();
		void start(int ms_offset, int ms_period=0, int round_ms=-1);
		void start(struct timespec *abstime, int ms_period=0);
		void stop();
		void trigger();
		static void get_time(struct timespec *now);
		static void inc_time(struct timespec *now, int ms);
		static bool cmp_time(struct timespec *tim, struct timespec *limit);
        friend ostream& operator<<(ostream &os,Timer &timer);
};

#endif
